/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.kernel.ws.api;

import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebResult;
import javax.jws.WebService;

import org.ow2.petals.kernel.ws.api.to.Component;
import org.ow2.petals.kernel.ws.api.to.ServiceAssembly;
import org.ow2.petals.kernel.ws.api.to.SharedLib;

/**
 * @author Christophe HAMERLING - EBM WebSourcing
 */
@WebService
public interface JBIArtefactsService {

    public static final String COMPONENT = "component";

    public static final String BINDING = "binding";

    public static final String ENGINE = "engine";

    /**
     * Get the list of service assemblies
     *
     * @return
     * @throws PEtALSWebServiceException
     */
    @WebMethod
    @WebResult(name = "sa")
    List<ServiceAssembly> getServiceAssemblies() throws PEtALSWebServiceException;

    @WebMethod
    List<Component> getComponents() throws PEtALSWebServiceException;

    @WebMethod
    List<SharedLib> getSharedLibraries() throws PEtALSWebServiceException;

}
