/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.kernel.ws.api;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.xml.namespace.QName;

/**
 * @author Christophe HAMERLING - EBM WebSourcing
 */
@WebService
public interface MonitoringManagementService {

    @WebMethod
    boolean isMonitoringActive(@WebParam(name = "module") QName module)
            throws PEtALSWebServiceException;

    @WebMethod
    QName[] getMonitoredModules() throws PEtALSWebServiceException;

    @WebMethod(operationName = "activateMonitoringOnModule")
    boolean activateMonitoring(@WebParam(name = "module") QName module)
            throws PEtALSWebServiceException;

    @WebMethod(operationName = "activateMonitoringOnModules")
    boolean activateMonitoring(@WebParam(name = "module") QName[] modules)
            throws PEtALSWebServiceException;

    @WebMethod(operationName = "disableMonitoringOnModule")
    boolean disableMonitoring(@WebParam(name = "module") QName module)
            throws PEtALSWebServiceException;

    @WebMethod(operationName = "disableMonitoringOnModules")
    boolean disableMonitoring(@WebParam(name = "module") QName[] modules)
            throws PEtALSWebServiceException;
}
