/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.kernel.ws.api.to;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

import org.ow2.petals.kernel.ws.api.Constants;

/**
 * TODO : To be completed with more information
 * @author Christophe Hamerling - EBM WebSourcing
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(namespace = Constants.NS, name = "container-information")
public class ContainerInformation {

    @XmlElement(name="container-name", required=true, nillable=false)
    private String name;

    @XmlElement(name="container-description", required=false, nillable=true)
    private String description;

    @XmlElement(name="container-host", required=true, nillable=false)
    private String host;

    @XmlElement(name="container-user", required=true, nillable=false)
    private String user;

    @XmlElement(name="container-password", required=true, nillable=false)
    private String password;

    @XmlElement(required=true, nillable=false)
    private JmxServiceInformation jmxService;

    @XmlElement(required=true, nillable=false)
    private TransportServiceInformation transportService;

    public ContainerInformation() {

    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public String getUser() {
        return user;
    }

    public void setUser(String user) {
        this.user = user;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public JmxServiceInformation getJmxService() {
        return jmxService;
    }

    public void setJmxService(JmxServiceInformation jmxService) {
        this.jmxService = jmxService;
    }

    public TransportServiceInformation getTransportService() {
        return transportService;
    }

    public void setTransportService(TransportServiceInformation transportService) {
        this.transportService = transportService;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ContainerInformation other = (ContainerInformation) obj;
        if ((this.name == null) ? (other.name != null) : !this.name.equals(other.name)) {
            return false;
        }
        if ((this.description == null) ? (other.description != null) : !this.description.equals(other.description)) {
            return false;
        }
        if ((this.host == null) ? (other.host != null) : !this.host.equals(other.host)) {
            return false;
        }
        if ((this.user == null) ? (other.user != null) : !this.user.equals(other.user)) {
            return false;
        }
        if ((this.password == null) ? (other.password != null) : !this.password.equals(other.password)) {
            return false;
        }
        if (this.jmxService != other.jmxService && (this.jmxService == null || !this.jmxService.equals(other.jmxService))) {
            return false;
        }
        if (this.transportService != other.transportService && (this.transportService == null || !this.transportService.equals(other.transportService))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + (this.name != null ? this.name.hashCode() : 0);
        hash = 97 * hash + (this.description != null ? this.description.hashCode() : 0);
        hash = 97 * hash + (this.host != null ? this.host.hashCode() : 0);
        hash = 97 * hash + (this.user != null ? this.user.hashCode() : 0);
        hash = 97 * hash + (this.password != null ? this.password.hashCode() : 0);
        hash = 97 * hash + (this.jmxService != null ? this.jmxService.hashCode() : 0);
        hash = 97 * hash + (this.transportService != null ? this.transportService.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        StringBuilder toStringBuilder = new StringBuilder();
        toStringBuilder.append("ContainerInformation [");
        toStringBuilder.append("container-name=").append(this.name).append(", ");
        toStringBuilder.append("container-description=").append(this.description).append(", ");
        toStringBuilder.append("container-host=").append(this.host).append(", ");
        toStringBuilder.append("container-user=").append(this.user).append(", ");
        toStringBuilder.append("container-password=").append(this.password).append(", ");
        toStringBuilder.append(this.jmxService).append(", ");
        toStringBuilder.append(this.transportService).append("]");

        return toStringBuilder.toString();
    }
}
